diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/s_conf.c ircd-hybrid-6.0/src/s_conf.c
--- ircd-hybrid-6.0.orig/src/s_conf.c	Fri Jun  8 18:03:39 2001
+++ ircd-hybrid-6.0/src/s_conf.c	Fri Jun  8 17:30:17 2001
@@ -40,6 +40,7 @@
 #include "send.h"
 #include "struct.h"
 #include "s_debug.h"
+#include "umodes.h"
 
 #include <stdio.h>
 #include <string.h>
@@ -90,8 +91,7 @@
 struct ConfItem *temporary_ip_klines = NULL;
 
 static  char *set_conf_flags(struct ConfItem *,char *);
-static  int  oper_privs_from_string(int,char *);
-static  int  oper_flags_from_string(char *);
+static  void oper_flags_from_string(umode_t*, char *);
 
 /* externally defined functions */
 extern  void    outofmemory(void);        /* defined in list.c */
@@ -294,7 +294,7 @@
               c = 'c';
 
             /* Don't allow non opers to see actual ips */
-            if(IsAnOper(sptr))
+            if(IsSetOperAuspex(sptr))
               sendto_one(sptr, form_str(p->rpl_stats), me.name,
                          sptr->name, c,
 #ifdef SERVERHIDE
@@ -305,7 +305,7 @@
                          name,
                          port,
                          get_conf_class(tmp),
-                         oper_flags_as_string((int)tmp->hold));
+                         oper_flags_as_string(tmp->default_umodes));
             else
               sendto_one(sptr, form_str(p->rpl_stats), me.name,
                          sptr->name, c,
@@ -318,21 +318,21 @@
         else if(mask & (CONF_OPERATOR|CONF_LOCOP))
           {
             /* Don't allow non opers to see oper privs */
-            if(IsAnOper(sptr))
+            if(SeesOpers(sptr))
               sendto_one(sptr, form_str(p->rpl_stats), me.name,
                          sptr->name,
                          p->conf_char,
                          user, host, name,
-                         oper_privs_as_string((struct Client *)NULL,port),
+                         oper_flags_as_string(tmp->allowed_umodes),
                          get_conf_class(tmp),
-                         oper_flags_as_string((int)tmp->hold));
+                         oper_flags_as_string(tmp->default_umodes));
             else
               sendto_one(sptr, form_str(p->rpl_stats), me.name,
                          sptr->name,
                          p->conf_char,
                          user,
 #ifdef SERVERHIDE
-                         IsAnOper(sptr) ? host : "255.255.255.255",
+                         IsSetOperAuspex(sptr) ? host : "255.255.255.255",
 #else
                          host,
 #endif
@@ -2075,29 +2075,20 @@
 	  /* user field */
           if ((tmp = getfield(NULL)) == NULL)
             break;
-          /*from comstud */
-
+          /*from comstud*/
           if(aconf->status & CONF_CLIENT)
             tmp = set_conf_flags(aconf, tmp);
           DupString(aconf->user, tmp);
 
 	  /* port field */
-          if(aconf->status & CONF_OPERATOR)
+          if((aconf->status & CONF_OPERATOR) | (aconf->status & CONF_LOCOP))
             {
               /* defaults */
-              aconf->port = 
-                CONF_OPER_GLOBAL_KILL|CONF_OPER_REMOTE|CONF_OPER_UNKLINE|
-                CONF_OPER_K|CONF_OPER_GLINE|CONF_OPER_REHASH;
-              if ((tmp = getfield(NULL)) == NULL)
-                break;
-              aconf->port = oper_privs_from_string(aconf->port,tmp);
-            }
-          else if(aconf->status & CONF_LOCOP)
-            {
-              aconf->port = CONF_OPER_UNKLINE|CONF_OPER_K;
+	      log(L_NOTICE, "Reading allowed umodes for %s", aconf->user);
+	      ClearBitfield(aconf->allowed_umodes);
               if ((tmp = getfield(NULL)) == NULL)
                 break;
-              aconf->port = oper_privs_from_string(aconf->port,tmp);
+              oper_flags_from_string(&(aconf->allowed_umodes),tmp);
             }
           else
             {
@@ -2135,9 +2126,11 @@
 
           if(aconf->status & (CONF_LOCOP|CONF_OPERATOR))
             {
+	      log(L_NOTICE, "Reading default umodes for %s", aconf->user);
+	      ClearBitfield(aconf->default_umodes);
               if ((tmp = getfield(NULL)) == NULL)
                 break;
-              aconf->hold = oper_flags_from_string(tmp);
+              oper_flags_from_string(&(aconf->default_umodes), tmp);
             }
 
           break;
@@ -2590,7 +2583,7 @@
         sendto_realops("Can't open %s include file",include_list->name);
       else
         {
-          sendto_realops_flags(FLAGS_DEBUG, "Hashing in %s include file",include_list->name);
+          sendto_realops_flag(UMODE_DEBUG, "Hashing in %s include file",include_list->name);
           initconf(file, NO);
         }
       free_conf(include_list);
@@ -2928,7 +2921,7 @@
           else
             reason = "No Reason";
 
-          if(!IsAnOper(sptr))
+          if(!CanSeeKlines(sptr))
             {
               if( (p = strchr(reason,'|')) )
                 *p = '\0';
@@ -2948,212 +2941,6 @@
     }
 }
 
-/* oper_privs_from_string
- *
- * inputs        - default privs
- *               - privs as string
- * output        - default privs as modified by privs string
- * side effects -
- *
- */
-
-static int oper_privs_from_string(int int_privs,char *privs)
-{
-  while(*privs)
-    {
-      if(*privs == 'O')                     /* allow global kill */
-        int_privs |= CONF_OPER_GLOBAL_KILL;
-      else if(*privs == 'o')                /* disallow global kill */
-        int_privs &= ~CONF_OPER_GLOBAL_KILL;
-      else if(*privs == 'U')                /* allow unkline */
-        int_privs |= CONF_OPER_UNKLINE;
-      else if(*privs == 'u')                /* disallow unkline */
-        int_privs &= ~CONF_OPER_UNKLINE;
-      else if(*privs == 'R')                /* allow remote squit/connect etc.*/
-        int_privs |= CONF_OPER_REMOTE;        
-      else if(*privs == 'r')                /* disallow remote squit/connect etc.*/
-        int_privs &= ~CONF_OPER_REMOTE;
-      else if(*privs == 'N')                /* allow +n see nick changes */
-        int_privs |= CONF_OPER_N;
-      else if(*privs == 'n')                /* disallow +n see nick changes */
-        int_privs &= ~CONF_OPER_N;
-      else if(*privs == 'K')                /* allow kill and kline privs */
-        int_privs |= CONF_OPER_K;
-      else if(*privs == 'k')                /* disallow kill and kline privs */
-        int_privs &= ~CONF_OPER_K;
-#ifdef GLINES
-      else if(*privs == 'G')                /* allow gline */
-        int_privs |= CONF_OPER_GLINE;
-      else if(*privs == 'g')                /* disallow gline */
-        int_privs &= ~CONF_OPER_GLINE;
-#endif
-#ifdef GODOPERS
-      else if(*privs == 'P')                /* allow apotheosis */
-        int_privs |= CONF_OPER_GOD;
-      else if(*privs == 'p')                /* disallow apotheosis */
-        int_privs &= ~CONF_OPER_GOD;
-#endif
-      else if(*privs == 'H')                /* allow rehash */
-        int_privs |= CONF_OPER_REHASH;
-      else if(*privs == 'h')                /* disallow rehash */
-        int_privs &= ~CONF_OPER_REHASH;
-      else if(*privs == 'D')
-        int_privs |= CONF_OPER_DIE;         /* allow die */
-      else if(*privs == 'd')
-        int_privs &= ~CONF_OPER_DIE;        /* disallow die */
-      else if(*privs == 'M')
-        int_privs |= CONF_OPER_M;           /* allow immunity */
-      else if(*privs == 'm')
-        int_privs &= ~CONF_OPER_M;          /* disallow immunity */
-      else if(*privs == 'A')
-        int_privs |= CONF_OPER_AUSPEX;      /* allow seeing the invisible */
-      else if(*privs == 'a')
-        int_privs &= ~CONF_OPER_AUSPEX;     /* disallow seeing the invisible */
-#ifdef CHANNEL_CREATION_NOTICE
-      else if(*privs == 'L')
-        int_privs |= CONF_OPER_CHCREATE;    /* allow seeing new chans */
-      else if(*privs == 'l')
-        int_privs &= ~CONF_OPER_CHCREATE;   /* disallow seeing new  chans */
-#endif /* CHANNEL_CREATION_NOTICE */
-
-      privs++;
-    }
-
-  return(int_privs);
-}
-
-/*
- * oper_privs_as_string
- *
- * inputs        - pointer to cptr or NULL
- * output        - pointer to static string showing oper privs
- * side effects  -
- * return as string, the oper privs as derived from port
- * also, set the oper privs if given cptr non NULL
- */
-
-char *oper_privs_as_string(aClient *cptr,int port)
-{
-  static char privs_out[16];
-  char *privs_ptr;
-
-  privs_ptr = privs_out;
-  *privs_ptr = '\0';
-
-  if(port & CONF_OPER_GLINE)
-    {
-      if(cptr)
-        SetOperGline(cptr);
-      *privs_ptr++ = 'G';
-    }
-  else
-    *privs_ptr++ = 'g';
-
-  if(port & CONF_OPER_K)
-    {
-      if(cptr)
-        SetOperK(cptr);
-      *privs_ptr++ = 'K';
-    }
-  else
-    *privs_ptr++ = 'k';
-
-  if(port & CONF_OPER_M)
-    {
-      if(cptr)
-        SetOperM(cptr);
-      *privs_ptr++ = 'M';
-    }
-  else
-    *privs_ptr++ = 'm';
-  
-  if(port & CONF_OPER_AUSPEX)
-    {
-      if(cptr)
-        SetOperAuspex(cptr);
-      *privs_ptr++ = 'A';
-    }
-  else
-    *privs_ptr++ = 'a';
-  
-  if(port & CONF_OPER_N)
-    {
-      if(cptr)
-        SetOperN(cptr);
-      *privs_ptr++ = 'N';
-    }
-
-  if(port & CONF_OPER_GLOBAL_KILL)
-    {
-      if(cptr)
-        SetOperGlobalKill(cptr);
-      *privs_ptr++ = 'O';
-    }
-  else
-    *privs_ptr++ = 'o';
-
-  if(port & CONF_OPER_REMOTE)
-    {
-      if(cptr)
-        SetOperRemote(cptr);
-      *privs_ptr++ = 'R';
-    }
-  else
-    *privs_ptr++ = 'r';
-  
-  if(port & CONF_OPER_UNKLINE)
-    {
-      if(cptr)
-        SetOperUnkline(cptr);
-      *privs_ptr++ = 'U';
-    }
-  else
-    *privs_ptr++ = 'u';
-
-  if(port & CONF_OPER_REHASH)
-    {
-      if(cptr)
-        SetOperRehash(cptr);
-      *privs_ptr++ = 'H';
-    }
-  else
-    *privs_ptr++ = 'h';
-
-#ifdef GODOPERS
-  if(port & CONF_OPER_GOD)
-    {
-      if(cptr)
-        SetOperGod(cptr);
-      *privs_ptr++ = 'P';
-    }
-  else
-    *privs_ptr++ = 'p';
-#endif
-  if(port & CONF_OPER_DIE)
-    {
-      if(cptr)
-        SetOperDie(cptr);
-      *privs_ptr++ = 'D';
-    }
-  else
-    *privs_ptr++ = 'd';
-
-#ifdef CHANNEL_CREATION_NOTICE
-  if(port & CONF_OPER_CHCREATE)
-    {
-      if(cptr)
-        SetOperChanCreate(cptr);
-      *privs_ptr++ = 'L';
-    }
-  else
-    *privs_ptr++ = 'l';
-#endif
-
-  *privs_ptr = '\0';
-
-  return(privs_out);
-}
-
 /* oper_flags_from_string
  *
  * inputs        - flags as string
@@ -3163,44 +2950,13 @@
  * -Dianora
  */
 
-static int oper_flags_from_string(char *flags)
+static void oper_flags_from_string(umode_t* u, char *flags)
 {
-  int int_flags=0;
-
   while(*flags)
     {
-      if(*flags == 'i')                        /* invisible */
-        int_flags |= FLAGS_INVISIBLE;
-      else if(*flags == 'w')                /* see wallops */
-        int_flags |= FLAGS_WALLOP;
-      else if(*flags == 's')
-        int_flags |= FLAGS_SERVNOTICE;
-      else if(*flags == 'c')
-        int_flags |= FLAGS_CCONN;
-      else if(*flags == 'r')
-        int_flags |= FLAGS_REJ;
-      else if(*flags == 'k')
-        int_flags |= FLAGS_SKILL;
-      else if(*flags == 'f')
-        int_flags |= FLAGS_FULL;
-      else if(*flags == 'y')
-        int_flags |= FLAGS_SPY;
-#ifdef GODOPERS
-      else if(*flags == 'p')
-        int_flags |= FLAGS_GOD;
-#endif
-      else if(*flags == 'd')
-        int_flags |= FLAGS_DEBUG;
-      else if(*flags == 'n')
-        int_flags |= FLAGS_NCHANGE;
-      else if(*flags == 'm')
-        int_flags |= FLAGS_IMMUNE;
-      else if(*flags == 'a')
-        int_flags |= FLAGS_AUSPEX;
+      SetBit((*u), user_modes_from_c_to_bitmask[(unsigned char)*flags]);
       flags++;
     }
-
-  return(int_flags);
 }
 
 /* oper_flags_as_string
@@ -3212,44 +2968,21 @@
  * -Dianora
  */
 
-char *oper_flags_as_string(int flags)
+char *oper_flags_as_string(umode_t flags)
 {
-  static char flags_out[16];
+  static char flags_out[BITFIELD_SIZE]; /* we need more flags -- asuffield */
   char *flags_ptr;
+  int i;
 
   flags_ptr = flags_out;
   *flags_ptr = '\0';
 
-  if(flags & FLAGS_INVISIBLE)
-    *flags_ptr++ = 'i';
-  if(flags & FLAGS_WALLOP)
-    *flags_ptr++ = 'w';
-  if(flags & FLAGS_SERVNOTICE)
-    *flags_ptr++ = 's';
-  if(flags & FLAGS_CCONN)
-    *flags_ptr++ = 'c';
-  if(flags & FLAGS_REJ)
-    *flags_ptr++ = 'r';
-  if(flags & FLAGS_SKILL)
-    *flags_ptr++ = 'k';
-  if(flags & FLAGS_FULL)
-    *flags_ptr++ = 'f';
-  if(flags & FLAGS_SPY)
-    *flags_ptr++ = 'y';
-#ifdef GODOPERS
-  if(flags & FLAGS_GOD)
-    *flags_ptr++ = 'p';
-#endif
-  if(flags & FLAGS_DEBUG)
-    *flags_ptr++ = 'd';
-  if(flags & FLAGS_NCHANGE)
-    *flags_ptr++ = 'n';
-  if(flags & FLAGS_IMMUNE)
-    *flags_ptr++ = 'm';
-  if(flags & FLAGS_AUSPEX)
-    *flags_ptr++ = 'a';
+  for (i = 0; user_modes[i].letter; i++ )
+    {
+      if (TestBit(flags, user_modes[i].mode))
+	*flags_ptr++ = user_modes[i].letter;
+    }
   *flags_ptr = '\0';
-
   return(flags_out);
 }
 
@@ -3436,7 +3169,7 @@
   char *host, *pass, *user, *name, *given_host, *given_name, *p;
   int port;
 
-  if (!MyClient(sptr) || !IsAnOper(sptr))
+  if (!MyClient(sptr) || !CanDoTestline(sptr))
     {
       sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
       return 0;
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/s_misc.c ircd-hybrid-6.0/src/s_misc.c
--- ircd-hybrid-6.0.orig/src/s_misc.c	Tue Nov 21 06:49:32 2000
+++ ircd-hybrid-6.0/src/s_misc.c	Fri Jun  8 16:10:55 2001
@@ -158,7 +158,7 @@
        * been removed. Also, do not allow non opers to see the IP's of servers
        * on stats ?
        */
-      if(IsAnOper(cptr))
+      if(IsSetOperAuspex(cptr))
         sendto_one(cptr, Lformat, me.name, RPL_STATSLINKINFO, name,
 #ifdef SERVERHIDE
                    get_client_name(acptr, HIDEME),
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/s_serv.c ircd-hybrid-6.0/src/s_serv.c
--- ircd-hybrid-6.0.orig/src/s_serv.c	Fri Jun  8 18:03:40 2001
+++ ircd-hybrid-6.0/src/s_serv.c	Wed Jun  6 18:38:29 2001
@@ -149,7 +149,7 @@
    * non-matching lookups.
    */
 #ifdef SERVERHIDE
-  if ( !(MyClient(sptr) && !IsOper(sptr))
+  if ( !(MyClient(sptr) && !SeesAllConnections(sptr))
       && (acptr = find_client(parv[server], NULL)) )
 #else
   if ((acptr = find_client(parv[server], NULL)))
@@ -171,7 +171,7 @@
   if (!acptr)
     {
 #ifdef SERVERHIDE
-      if ((!wilds || (MyClient(sptr) && !IsOper(sptr))))
+      if ((!wilds || (MyClient(sptr) && !SeesAllConnections(sptr))))
 #else
       if (!wilds)
 #endif
@@ -474,7 +474,7 @@
 
   if (IsPerson(acptr))
     {
-      send_umode(NULL, acptr, 0, SEND_UMODES, ubuf);
+      send_umode(NULL, acptr, 0, send_umodes, ubuf);
       if (!*ubuf)
         { /* trivial optimization - Dianora */
           
